<template>
  <v-flex xs4>
    <v-card>
      <div id="map"></div>
    </v-card>
  </v-flex>
</template>

<script>
import $Scriptjs from 'scriptjs';
import { eventBus } from '@/event-bus.js';

export default {
  name: "Map",
  data() {
    return {
      map: null,
      marker: null,
      lastLat: null,
      lastLng: null,

      getNextPage: null,

      // dfalt bangsue
      DEFAULT_LAT: 13.8170403,
      DEFAULT_LNG: 100.5200337,

      geocoder: null,
      placesService: null,

      mapGoogleGeometryMultiPoly: null,
      mapNumGeometries: 0,
    }
  },

  mounted: function() {
    // use your own key...
    $Scriptjs("https://maps.googleapis.com/maps/api/js?key=AIzaSyBIwzALxUPNbatRBj3Xi1Uhp0fFzwWNBkE&libraries=geometry,places", () => {
      this.initMap();
    });

    eventBus.$on('newTextAddress', (payload) => {
      this.updateFromTextAddress(payload);
    });

    eventBus.$on('launchKeywordSearch', (payload) => {
      this.doKeywordSearch(payload);
    })

  },

  methods: {

    onLoad(data,is_bounc){
        var icon = {
                  url: require("../assets/restaurant.png"), // url
                  scaledSize: new google.maps.Size(50, 50), // scaled size
                  origin: new google.maps.Point(0,0), // origin
                  anchor: new google.maps.Point(0, 0) // anchor
              };

              for (var i = 0; i < data.length; i++) {

                  let m = new google.maps.Marker({
                      animation: google.maps.Animation.DROP,
                      position: new google.maps.LatLng(data[i].lat, data[i].lng),
                      title: data[i].name,
                      map: this.map,
                      icon:icon,

                  });
                
                if(is_bounc){  

                  m.setMap(this.map);
                  m.setAnimation(null);
                  m.setAnimation(google.maps.Animation.BOUNCE)
                }

              }

    },
    // simple way to sleep..
    wait (timeout) {
      return new Promise((resolve) => {
        setTimeout(() => {
          resolve()
        }, timeout)
      })
    },

    updateFromTextAddress(payload) {
      this.map.setCenter(payload.geometry.location);
      this.updateMarker(payload.geometry.location);
      this.lastLat = payload.geometry.location.lat();
      this.lastLng = payload.geometry.location.lng();
    },


    initMap() {
      console.log("initMap");

      this.geocoder = new google.maps.Geocoder();

      this.map = new google.maps.Map(document.getElementById("map"), {
        center: {
          lat: this.DEFAULT_LAT,
          lng: this.DEFAULT_LNG
        },
        zoom: 14,

      });

      

      this.placesService = new google.maps.places.PlacesService(this.map);

      google.maps.event.addListener(this.map, "click", (event) => {
        this.lastLat = event.latLng.lat();
        this.lastLng = event.latLng.lng();

        this.updateMarker(event.latLng);

        this.geocoder.geocode({'location': event.latLng}, (results, status) => {
          if (results) {
            eventBus.$emit('mapAddress', results);
          }
        });
      });

      // tell the event bus
      eventBus.$emit('googleInit', {});

    //connect Web api rest ful
    fetch("http://localhost:53157/api/Restaurant/get")
                  .then(response => response.json())
                  .then((data) => {
                      
                      this.onLoad(data,false);


    })

    },

    updateMarker(latLng) {
      if (!this.marker) {
        this.marker = new google.maps.Marker({
          map: this.map
        });
      }

      this.marker.setPosition(latLng);
    },

    searchResultMarkers(results) {

      let filteredresults = results;

      if (this.mapNumGeometries > 0 && this.mapGoogleGeometryMultiPoly) {
        filteredresults = [];

        results.map((curPlace) => {          
          for (let i = 0; i < this.mapNumGeometries; i++) {
            if (google.maps.geometry.poly.containsLocation(
              curPlace.geometry.location,
              this.mapGoogleGeometryMultiPoly [i]) == true) {
                filteredresults.push(curPlace);
            }
          }
        });
      }

      // data with googal map
      filteredresults.map((place) => {
        let image = {
          url: place.icon,
          size: new google.maps.Size(50, 50),
          origin: new google.maps.Point(0, 0),
          anchor: new google.maps.Point(0, 0),
          scaledSize: new google.maps.Size(20, 20)
        };
  
        let marker = new google.maps.Marker({
          map: this.map,
          icon: image,
          title: place.name,
          position: place.geometry.location
        });

        
      })

    },


    doSearch(params) {

      console.log("doSearch");
      console.log(params);
      // yeah, I know, using _this ...
      // I really dont like how Google sets up pagination for this (compared to Yelp and others)
      // I should write this as a var pointing to a function definition etc...
      let _this = this;

      this.placesService.nearbySearch(params,
        async function (results, PlacesServiceStatus, PlaceSearchPagination) {

          if (PlacesServiceStatus !== 'OK') return;

          _this.searchResultMarkers(results);

          if (PlaceSearchPagination.hasNextPage) {
            // slight pause...
            await _this.wait(100); 
            _this.getNextPage = PlaceSearchPagination.hasNextPage && function() {
              PlaceSearchPagination.nextPage();
            }
          } else {  // null this so that we dont double up on api calls
            _this.getNextPage = null;
          }

          // invoke...
          if (_this.getNextPage) {
            _this.getNextPage();
          }
        }

      );
    },

    googlePlacesSearch(keyword, radius = 1000) {

      console.log("googlePlacesSearch");

      if (!keyword.trim()) return;

      let params = {
        location: new google.maps.LatLng(this.lastLat, this.lastLng),
        radius: radius,
        keyword: keyword
      };

      console.log(params);

      this.doSearch(params);


    },

    doKeywordSearch(keyword) {
      // one could expand here to search other services besides Google...
      this.googlePlacesSearch(keyword, 500);
      this.ApiPlacesSearch(keyword);
    },

    ApiPlacesSearch(keyword) {

      fetch("http://localhost:53157/api/Restaurant/get/"+keyword)
                        .then(response => response.json())
                        .then((data) => {
                            console.log(data);

                            this.onLoad(data,true);
                  

          })

    }


  
  }
}
</script>

<style>
#map {
  width: 90vw;
  height: 45vw;
}
</style>






 
